Open In App

Netskope Interview Experience | On-Campus 2019

Last Updated : 23 Oct, 2019
Improve
Improve
Like Article
Like
Save
Share
Report

Netskope visited my college during the first week of September, 2019. Their hiring process had five rounds which were elimination based. 

Round 1 – Campus test

This was an online Technical MCQ based test hosted on HackerEarth. More than 200 students appeared for the first round of the process. The test had 30 questions which should be solved within an hour of time. The questions were from core computer science subjects – Operating Systems, Computer Networks, DBMS, Data Structures and Algorithms.

Round 2 – Algorithms test

Around 110 students were shortlisted for the next round. This round was an online coding test hosted on HackerEarth. The test accepted all the programming languages supported by HackerEarth editor. There were 3 questions and the time duration was 1 hour 30 minutes.

Question 1 

Based on Chinese Remainder Theorem.

https://www.geeksforgeeks.org/chinese-remainder-theorem-set-1-introduction/

Question 2

Given an array of numbers of size N and variable k, do a right rotation of the array by one element for k times. Construct a square matrix of?N X?N for every new array formed by the right rotation. So there would be k+1 matrices in total. Multiply all  matrices and return sum of all of the elements of final matrix.

Question 3

Sorry!! I don’t remember it.

Note: This Algorithms test was purely on algorithms which give efficient solutions. Naive approaches didn’t work at all.

Round 3 – Technical Interview

Around 15 students were shortlisted from the Algorithms test for the technical interviews. I and the interviewer had a casual discussions about the online tests, my background, goals and interests before diving into the actual technical interview.This round had only two problem solving questions. 

Question 1

How do you find the intersection point of two linked lists?

Approach 1 – Use hashing 

1) Create an empty hash set.

2) Traverse the first linked list and insert all nodes’ addresses in the hash set.

3) Traverse the second list. For every node check if it is present in the hash set. If we find a node in the hash set, return the node.

Note: Refer Method 7 for implementation in the following link.

Approach 2 – Use difference of node counts

1) Get count of the nodes in the first list, let count be c1.

2) Get count of the nodes in the second list, let count be c2.

3) Get the difference of counts d = abs(c1 – c2)

4) Now traverse the bigger list from the first node till d nodes so that from here onward both the lists have equal number of nodes.

5) Then we can traverse both the lists in parallel until we come across a common node. (Note that getting a common node is done by comparing the address of the nodes) 

I gave these two approaches, but the interviewer wanted me to use stacks to solve this problem.

So the final approach is as follows.

Approach 3 – Use stacks

1) Stack the address of all nodes of first linked list.

2) Stack the address of all nodes of second linked list.

3) Pop elements from both stacks in parallel and compare the address.

4) If the addresses are the same, then continue with step 3.

5) If the addresses are different, the element popped before the current element is the intersection point. 

Note: Should handle all the border cases.

https://www.geeksforgeeks.org/write-a-function-to-get-the-intersection-point-of-two-linked-lists/

The interviewer asked me to write code for Approach 3 in C language.

Question 2

This was a puzzle.

He wrote a Duodecimal system (also known as base-12 or dozenal). Assuming that my memory serves right the following is the number system.

0, 1, 2, 3, A, 4, 5, 6, 7, B, 8, 9

He asked me to find what is the value of A² + 6B + 9 in this number system. 

Note: A² is different from AA.

Round 4 – Technical Interview

Only few us had this round and others were asked to leave. Again I and the interviewer had a casual discussions about my goals and interests before diving into the actual technical interview. There was problem solving along with questions on Operating systems and Computer networks. 

Question 1

Given a set of time intervals, merge overlapping intervals.

https://www.geeksforgeeks.org/merging-intervals/

Question 2

Write a program to find out if the given system is a little endian or big endian. 

Actually this question came up after asking OS concepts. 

Round 5 – HR round

The HR asked how my day was and the interviews. After that he asked me to tell about myself. He listened to me and asked questions in between. Finally the results were sent via the placement office.

Tips: 

Honesty is the best policy. Though it sounds old, it really worked for me. Along with our solutions to the questions being confident is equally important.

Ask for feedback directly from the interviewer. This helps in our improvement. 

With peace,

GMKB


Like Article
Suggest improvement
Previous
Next
Share your thoughts in the comments

Similar Reads